/*
 * A simple pager exposing a single memory region.
 *
 * Copyright (C) 2021 Paul Boddie <paul@boddie.org.uk>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA
 */

#pragma once

#include <fsserver/dataspace_interface.h>
#include <mem/flexpage.h>
#include <mem/memory.h>
#include <fsserver/resource.h>



/* A simple pager exposing a single memory region as a dataspace. */

class SimplePager : public Dataspace, public Resource
{
protected:
    Memory *_memory;
    Region *_region;

public:
    explicit SimplePager(Memory *memory=NULL);

    void close();

    /* Paging methods. */

    long map(offset_t offset, address_t hot_spot, map_flags_t flags, l4_snd_fpage_t *region);

    long info(offset_t *size, map_flags_t *flags);
};

// vim: tabstop=4 expandtab shiftwidth=4
